package cn.yw.archive.companymanage.action;

 import cn.yw.archive.companymanage.service.YwarchivecompanypersonService;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import cn.base.aspect.OperateType;
import cn.base.bean.BaseAction;
import cn.base.excel.ExcelCol;
import cn.base.excel.ExportEngine;
import cn.base.util.CommUtils;
import cn.base.util.Constants;
import cn.base.util.LogConstants;
import cn.base.util.StringUtil;
import cn.base.util.Struts2Utils;

@SuppressWarnings({"all"})
@Component("ywarchivecompanypersonAction")
public class YwarchivecompanypersonAction extends BaseAction{
	private static final long serialVersionUID = 1L;
	private static Logger iLog = Logger.getLogger(YwarchivecompanypersonAction.class);
	
	@Autowired
	private YwarchivecompanypersonService service;
	
	/**
	 * 分页
	 */
	@OperateType(value = LogConstants.LOG_QUERY ,info ="listYwarchivecompanypersonByPage")
	public void listYwarchivecompanypersonByPage(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listYwarchivecompanypersonByPage(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwarchivecompanypersonAction-listYwarchivecompanypersonByPage-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询总数
	 */
	@OperateType(value = LogConstants.LOG_QUERY ,info ="count_Ywarchivecompanyperson")
	public void count_Ywarchivecompanyperson(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_Ywarchivecompanyperson(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwarchivecompanypersonAction-count_Ywarchivecompanyperson-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询 Ywarchivecompanyperson
	 */
	/*
	@OperateType(value = LogConstants.LOG_GET ,info ="query_Ywarchivecompanyperson")
	public void query_Ywarchivecompanyperson(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.query_Ywarchivecompanyperson(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwarchivecompanypersonAction-query_Ywarchivecompanyperson-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 查询 一条Ywarchivecompanyperson
	 */
	/*
	@OperateType(value = LogConstants.LOG_GET ,info ="get_Ywarchivecompanyperson")
	public void get_Ywarchivecompanyperson(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.get_Ywarchivecompanyperson(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwarchivecompanypersonActionquery_Ywarchivecompanyperson-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="deleteYwarchivecompanyperson")
	public void delete_Ywarchivecompanyperson(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!CommUtils.isEmpty(map)){
				int result = service.delete_Ywarchivecompanyperson(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}else{
				 throw new Exception("请正确的选择删除记录!!!");
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwarchivecompanypersonAction-delete_Ywarchivecompanyperson-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}

	/**
	 * 插入
	 */
	@OperateType(value = LogConstants.LOG_ADD ,info ="insert_Ywarchivecompanyperson")
	public void insert_Ywarchivecompanyperson(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(StringUtil.checkEmpty(map.get("personid"))){
				map.put("personid",StringUtil.getUUID());
			}
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Ywarchivecompanyperson(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					service.insert_Ywarchivecompanyperson(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				service.insert_Ywarchivecompanyperson(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwarchivecompanypersonAction-insert_Ywarchivecompanyperson()-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 修改
	 */
	@OperateType(value = LogConstants.LOG_UPDATE ,info ="update_Ywarchivecompanyperson")
	public void update_Ywarchivecompanyperson(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Ywarchivecompanyperson(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					int result = service.update_Ywarchivecompanyperson(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				int result = service.update_Ywarchivecompanyperson(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwarchivecompanypersonAction-update_Ywarchivecompanyperson-error: " +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 批量删除
	 */
	/*
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_delete_Ywarchivecompanyperson")
	public void batch_delete_Ywarchivecompanyperson(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Map m = new HashMap();
			m.put("keyword", map.get("keyword").toString());
			int result = service.batch_delete_Ywarchivecompanyperson(m);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwarchivecompanypersonAction-batch_delete_Ywarchivecompanyperson-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 导出Excel
	 */
	@OperateType(value = LogConstants.LOG_EXPORT ,info ="exp_Ywarchivecompanyperson")
	public void exp_Ywarchivecompanyperson(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			map.put("start",0 );
			map.put("limit",5000);
			List<Map> sList = service.query_Ywarchivecompanyperson(map);
			List<HashMap> expList = new ArrayList<HashMap>();
			for(Map m : sList){
				Map exportMap = new HashMap();
				exportMap.put("personid", m.get("personid"));
				exportMap.put("companyid", m.get("companyid"));
				exportMap.put("companyname", m.get("companyname"));
				exportMap.put("persontype", m.get("persontype"));
				exportMap.put("personname", m.get("personname"));
				exportMap.put("personphone", m.get("personphone"));
				exportMap.put("personaddrarea", m.get("personaddrarea"));
				exportMap.put("personaddress", m.get("personaddress"));
				exportMap.put("remarks", m.get("remarks"));
				expList.add((HashMap) exportMap);
			}
			int excelNum = 9;
			ExcelCol[] cells = new ExcelCol[excelNum];
			String[] zdbm = {"personid", "companyid", "companyname", "persontype", "personname", "personphone", "personaddrarea", "personaddress", "remarks"};
			String[] zdmc = {"人员id", "公司id","公司名称","人员类型","人员姓名","人员手机","人员住址区划","人员住址详址","备注"};
			for(int i=0;i<excelNum;i++){
				cells[i] = new ExcelCol();
				cells[i].setColKey(zdbm[i]);
				cells[i].setColName(zdmc[i]);
			}		
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
        	String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "公司人员信息管理-"+dateTime);
			params.put("sheetName", "公司人员信息管理");
			params.put("header", "公司人员信息管理");	
//			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
			new ExportEngine().exportCommData(params, cells, expList, Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwarchivecompanypersonAction-exoprtExcel-error:" +e);
			
		}
	}
	
	/**
	 * 导入Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_IMPORT ,info ="imp_Ywarchivecompanyperson")
	public String imp_Ywarchivecompanyperson(String excelFile,Object user) {
		String rs = "导入格式有误!";
		int rowNum = 0;
		int dataCount = 0;
		int successNum = 0;
		int repeatNum = 0;
		int failNum = 0;
		try {
		
			ExcelReader readExcel = new ExcelReader();
			readExcel.openFile(excelFile);
			readExcel.setSheetNum(0);
			int count = readExcel.getRowCount();
			iLog.info("总行数count--->" + count);
			rs = " 导入数据成功！总共"+ dataCount +"条数据,重复"+repeatNum+"条数据！失败"+failNum+"条数据!";
			File file = new File(excelFile);
			if(file.exists()){
				file.delete();
			}
		} catch (Exception e) {
			if (rowNum > 3) {
				rs = "资源部分导入(更新)失败！Excel第" + rowNum + "行起未导入(更新)成功！";
			} else {
				rs = "资源导入(更新)失败！";
			}
			iLog.error("YwarchivecompanypersonAction-imp_Ywarchivecompanyperson-error:" +e);
			e.printStackTrace();
		}		
		return rs;
	}
	*/
}
